diff --git a/compiler/typecheck/TcSimplify.lhs b/compiler/typecheck/TcSimplify.lhs
index 16cabeb..046ba3a 100644
--- a/compiler/typecheck/TcSimplify.lhs
+++ b/compiler/typecheck/TcSimplify.lhs
@@ -1,10 +1,4 @@
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module TcSimplify( 
        simplifyInfer, quantifyPred,
@@ -41,7 +35,7 @@ import PrelInfo
 import PrelNames
 import Control.Monad    ( unless )
 import DynFlags         ( ExtensionFlag( Opt_AllowAmbiguousTypes ) )
-import Class		( classKey )
+import Class            ( classKey )
 import BasicTypes       ( RuleName )
 import Outputable
 import FastString
@@ -190,8 +184,8 @@ simplifyInteractive wanteds
     simplifyTop wanteds
 
 ------------------
-simplifyDefault :: ThetaType	-- Wanted; has no type variables in it
-                -> TcM ()	-- Succeeds iff the constraint is soluble
+simplifyDefault :: ThetaType    -- Wanted; has no type variables in it
+                -> TcM ()       -- Succeeds iff the constraint is soluble
 simplifyDefault theta
   = do { traceTc "simplifyInteractive" empty
        ; wanted <- newFlatWanteds DefaultOrigin theta
@@ -223,9 +217,9 @@ simplifyInfer :: Bool
               -> WantedConstraints
               -> TcM ([TcTyVar],    -- Quantify over these type variables
                       [EvVar],      -- ... and these constraints
-		      Bool,	    -- The monomorphism restriction did something
-		      		    --   so the results type is not as general as
-				    --   it could be
+                      Bool,         -- The monomorphism restriction did something
+                                    --   so the results type is not as general as
+                                    --   it could be
                       TcEvBinds)    -- ... binding these evidence variables
 simplifyInfer _top_lvl apply_mr name_taus wanteds
   | isEmptyWC wanteds
@@ -302,9 +296,9 @@ simplifyInfer _top_lvl apply_mr name_taus wanteds
                          `minusVarSet` gbl_tvs
              pbound    = filter (quantifyPred poly_qtvs) quant_pred_candidates
              
-	     -- Monomorphism restriction
+             -- Monomorphism restriction
              constrained_tvs = tyVarsOfTypes pbound `unionVarSet` gbl_tvs
-	     mr_bites        = apply_mr && not (null pbound)
+             mr_bites        = apply_mr && not (null pbound)
 
        ; (qtvs, bound) <- if mr_bites 
                           then do { qtvs <- quantifyTyVars constrained_tvs zonked_tau_tvs
@@ -363,27 +357,27 @@ simplifyInfer _top_lvl apply_mr name_taus wanteds
                 , mr_bites,  TcEvBinds ev_binds_var) } }
 
 quantifyPred :: TyVarSet           -- Quantifying over these
-	     -> PredType -> Bool   -- True <=> quantify over this wanted
+             -> PredType -> Bool   -- True <=> quantify over this wanted
 quantifyPred qtvs pred
   | isIPPred pred = True  -- Note [Inheriting implicit parameters]
-  | otherwise	  = tyVarsOfType pred `intersectsVarSet` qtvs
+  | otherwise     = tyVarsOfType pred `intersectsVarSet` qtvs
 \end{code}
 
 Note [Inheriting implicit parameters]
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 Consider this:
 
-	f x = (x::Int) + ?y
+        f x = (x::Int) + ?y
 
 where f is *not* a top-level binding.
 From the RHS of f we'll get the constraint (?y::Int).
 There are two types we might infer for f:
 
-	f :: Int -> Int
+        f :: Int -> Int
 
 (so we get ?y from the context of f's definition), or
 
-	f :: (?y::Int) => Int -> Int
+        f :: (?y::Int) => Int -> Int
 
 At first you might think the first was better, because then
 ?y behaves like a free variable of the definition, rather than
@@ -506,13 +500,13 @@ and if so refrain from quantifying over *any* equalites.
 
 \begin{code}
 simplifyRule :: RuleName 
-             -> WantedConstraints	-- Constraints from LHS
-             -> WantedConstraints	-- Constraints from RHS
+             -> WantedConstraints       -- Constraints from LHS
+             -> WantedConstraints       -- Constraints from RHS
              -> TcM ([EvVar], WantedConstraints)   -- LHS evidence varaibles
 -- See Note [Simplifying RULE constraints] in TcRule
 simplifyRule name lhs_wanted rhs_wanted
-  = do {      	 -- We allow ourselves to unify environment 
-		 -- variables: runTcS runs with NoUntouchables
+  = do {         -- We allow ourselves to unify environment 
+                 -- variables: runTcS runs with NoUntouchables
          (resid_wanted, _) <- solveWantedsTcM (lhs_wanted `andWC` rhs_wanted)
                               -- Post: these are zonked and unflattened
 
@@ -829,7 +823,7 @@ defaultTyVar the_tv
              -- See Note [DefaultTyVar]
              -- We keep the same Untouchables on tv'
 
-  | otherwise = return the_tv	 -- The common case
+  | otherwise = return the_tv    -- The common case
 
 approximateWC :: WantedConstraints -> Cts
 -- Postcondition: Wanted or Derived Cts 
@@ -1148,7 +1142,7 @@ applyDefaultingRules wanteds
 findDefaultableGroups 
     :: ( [Type]
        , (Bool,Bool) )  -- (Overloaded strings, extended default rules)
-    -> Cts	        -- Unsolved (wanted or derived)
+    -> Cts              -- Unsolved (wanted or derived)
     -> [[(Ct,Class,TcTyVar)]]
 findDefaultableGroups (default_tys, (ovl_strings, extended_defaults)) wanteds
   | null default_tys             = []
@@ -1173,7 +1167,7 @@ findDefaultableGroups (default_tys, (ovl_strings, extended_defaults)) wanteds
     cmp_tv (_,_,tv1) (_,_,tv2) = tv1 `compare` tv2
 
     is_defaultable_group ds@((_,_,tv):_)
-        = let b1 = isTyConableTyVar tv	-- Note [Avoiding spurious errors]
+        = let b1 = isTyConableTyVar tv  -- Note [Avoiding spurious errors]
               b2 = not (tv `elemVarSet` bad_tvs)
               b4 = defaultable_classes [cls | (_,cls,_) <- ds]
           in (b1 && b2 && b4)
@@ -1198,7 +1192,7 @@ findDefaultableGroups (default_tys, (ovl_strings, extended_defaults)) wanteds
 ------------------------------
 disambigGroup :: [Type]                  -- The default types 
               -> [(Ct, Class, TcTyVar)]  -- All classes of the form (C a)
-	      	 	          	 --  sharing same type variable
+                                         --  sharing same type variable
               -> TcS Bool   -- True <=> something happened, reflected in ty_binds
 
 disambigGroup []  _grp
@@ -1235,7 +1229,7 @@ Note [Avoiding spurious errors]
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 When doing the unification for defaulting, we check for skolem
 type variables, and simply don't default them.  For example:
-   f = (*)	-- Monomorphic
+   f = (*)      -- Monomorphic
    g :: Num a => a -> a
    g x = f x x
 Here, we get a complaint when checking the type signature for g,
diff --git a/compiler/typecheck/TcTyDecls.lhs b/compiler/typecheck/TcTyDecls.lhs
index f2969e6..8a7122c 100644
--- a/compiler/typecheck/TcTyDecls.lhs
+++ b/compiler/typecheck/TcTyDecls.lhs
@@ -9,12 +9,6 @@ This stuff is only used for source-code decls; it's recorded in interface
 files for imported data types.
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module TcTyDecls(
         calcRecFlags, RecTyInfo(..), 
@@ -144,7 +138,7 @@ and then *their* superclasses, and so on.  This set must be finite!
 It is OK for superclasses to be type synonyms for other classes, so
 must "look through" type synonyms. Eg
      type X a = C [a]
-     class X a => C a	-- No!  Recursive superclass!
+     class X a => C a   -- No!  Recursive superclass!
 
 We want definitions such as:
 
@@ -408,12 +402,12 @@ calcRecFlags boot_details is_boot mrole_env tyclss
 
     (new_tycons, prod_tycons) = partition isNewTyCon single_con_tycons
         -- NB: we do *not* call isProductTyCon because that checks
-	--     for vanilla-ness of data constructors; and that depends
-	--     on empty existential type variables; and that is figured
-	--     out by tcResultType; which uses tcMatchTy; which uses
-	--     coreView; which calls coreExpandTyCon_maybe; which uses
-	--     the recursiveness of the TyCon.  Result... a black hole.
-	-- YUK YUK YUK
+        --     for vanilla-ness of data constructors; and that depends
+        --     on empty existential type variables; and that is figured
+        --     out by tcResultType; which uses tcMatchTy; which uses
+        --     coreView; which calls coreExpandTyCon_maybe; which uses
+        --     the recursiveness of the TyCon.  Result... a black hole.
+        -- YUK YUK YUK
 
         --------------- Newtypes ----------------------
     nt_loop_breakers = mkNameSet (findLoopBreakers nt_edges)
@@ -525,9 +519,9 @@ isPromotableType rec_tcs con_arg_ty
                          && (tyConName tc `elemNameSet` rec_tcs 
                              || isJust (promotableTyCon_maybe tc))
                          && all go tys
-    go (FunTy arg res) 	 = go arg && go res
-    go (TyVarTy {})    	 = True
-    go _               	 = False
+    go (FunTy arg res)   = go arg && go res
+    go (TyVarTy {})      = True
+    go _                 = False
 \end{code}
 
 %************************************************************************
